<template>
    <div class="vh-100 d-flex justify-content-center align-items-center">
        <div class="container">
            <div class="row d-flex justify-content-center">
                <div class="col-12 col-md-8 col-lg-6">
                    <div class="card bg-white shadow-lg">
                        <div class="card-body p-5">
                            <div class="fw-bold my-2 text-uppercase text-center">
                                <img src="/logo.webp" alt="Logo" width="200" height="50" class="img-fluid">
                            </div>
                            <form class="mb-2 mt-md-4" @submit.prevent="register">
                                <h2 class="mb-3 text-uppercase text-center">Sing Up</h2>
                                <p class="text-danger mt-3" v-if="error">{{ error }}</p>
                                <div class="mb-3">
                                    <label for="name" class="form-label ">Name</label>
                                    <input type="text" class="form-control " id="name" placeholder="Enter your name"
                                        v-model="registerForm.name"
                                        :class="[v$.name.$error || errors.hasOwnProperty('name') ? 'is-invalid' : '']">
                                    <div class="invalid-feedback" v-if="v$.name.$error || errors.hasOwnProperty('name')">
                                        {{
                                            v$.name.$error ? v$.email.$errors[0].$message : (
                                                errors.hasOwnProperty('name') ? errors.name[0] : '') }}
                                    </div>
                                </div>

                                <div class="mb-3">
                                    <label for="email" class="form-label ">Email address</label>
                                    <input type="text" class="form-control " id="email"
                                        placeholder="Enter your email address" v-model="registerForm.email"
                                        :class="[v$.email.$error || errors.hasOwnProperty('email') ? 'is-invalid' : '']">
                                    <div class="invalid-feedback" v-if="v$.email.$error || errors.hasOwnProperty('email')">
                                        {{
                                            v$.email.$error ? v$.email.$errors[0].$message : (
                                                errors.hasOwnProperty('email') ? errors.email[0] : '') }}
                                    </div>
                                </div>
                                <div class="mb-3">
                                    <label for="password" class="form-label ">Password</label>
                                    <input type="password" class="form-control" id="password"
                                        placeholder="Enter your password" v-model="registerForm.password"
                                        :class="[v$.password.$error || errors.hasOwnProperty('password') ? 'is-invalid' : '']">
                                    <div class="invalid-feedback" v-if="v$.password.$error">{{
                                        v$.password.$errors[0].$message }}
                                    </div>
                                    <div class="invalid-feedback" v-if="errors.hasOwnProperty('password')">{{
                                        errors.password[0] }}
                                    </div>
                                </div>
                                <div class="mb-3">
                                    <label for="confirm_password" class="form-label ">Confirm Password</label>
                                    <input type="password" class="form-control" id="confirm_password"
                                        placeholder="Enter confirm password" v-model="registerForm.confirm_password"
                                        :class="[v$.confirm_password.$error || errors.hasOwnProperty('confirm_password') ? 'is-invalid' : '']">
                                    <div class="invalid-feedback" v-if="v$.confirm_password.$error">{{
                                        v$.confirm_password.$errors[0].$message }}
                                    </div>
                                    <div class="invalid-feedback" v-if="errors.hasOwnProperty('confirm_password')">{{
                                        errors.confirm_password[0] }}
                                    </div>
                                </div>
                                <div class="d-grid">
                                    <button class="btn btn-outline-dark" type="submit">Sign Up</button>
                                </div>
                            </form>
                            <div>
                                <p class="mb-0  text-center">Already have an account? <router-link :to="{ name: 'Login' }"
                                        class="text-primary fw-bold">Login
                                    </router-link></p>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</template>

<script>
import { reactive, ref } from 'vue'
import { useRouter } from 'vue-router'
import { useVuelidate } from '@vuelidate/core'
import { required, email, helpers } from '@vuelidate/validators'
import { useStore } from 'vuex'

export default {
    setup() {
        const router = useRouter();
        const store = useStore();

        let registerForm = reactive({
            name: '',
            email: '',
            password: '',
            confirm_password: '',
        });

        // Form validation rules
        const rules = {
            name: {
                required: helpers.withMessage('Name is required.', required),
            },
            email: {
                required: helpers.withMessage('Email address is required.', required),
                email: helpers.withMessage('Email address must be valid.', email),
            },
            password: { required: helpers.withMessage('Password is required.', required) },
            confirm_password: { required: helpers.withMessage('Confirm Password is required.', required) },
        }

        const v$ = useVuelidate(rules, registerForm);

        let error = ref('');
        let errors = ref([]);


        const register = async () => {
            const formValidate = await v$.value.$validate();
            if (formValidate) {
                await axios.post("/api/register", registerForm).
                    then(res => {
                        if (res.data.success) {
                            store.dispatch('setToken', res.data.data.token);
                            router.push({ name: 'Home' })
                        } else {
                            errors.value = res.data.message;
                        }
                    }).catch(e => {
                        if (e.response.status == 422) {
                            errors.value = e.response.data.data;
                        } else {
                            error.value = e.response.data.message;
                        }
                    });
            }
        }

        return {
            registerForm,
            register,
            error,
            errors,
            v$,

        }
    }
}
</script>
